#include <Windows.h>
#include <stdio.h>
#include "NtDefs.h"
#include "Main.h"
#include "Config.h"
//===========================================================================
TypeNtUnmapViewOfSection NtUnmapViewOfSection;
TypeNtCreateSection NtCreateSection;
TypeNtMapViewOfSection NtMapViewOfSection;
TypeNtClose NtClose;
//===========================================================================
int RemoteMain();
//===========================================================================
HANDLE hHandle = INVALID_HANDLE_VALUE;
//===========================================================================
DWORD dwPid = NULL;
DWORD dwClient = NULL;
DWORD dwEngine = NULL;
DWORD dwLocalPlayer = NULL;
DWORD dwEnginePtr = NULL;
//===========================================================================
BOOL m_boolBeep = FALSE;
BOOL m_boolLoopLock = FALSE;
//===========================================================================
#define M_PI 3.14159265358979323846
//===========================================================================
typedef LONG(WINAPI *RealNtFlushInstructionCache)(DWORD ProcessHandle, PVOID BaseAddress, ULONG NumberOfBytesToFlush);

RealNtFlushInstructionCache NewNtFlushInstructionCache = NULL;
//===========================================================================
typedef LONG(WINAPI *RealNtWriteVirtualMemory)(HANDLE ProcessHandle, PVOID BaseAddress, PVOID Buffer, ULONG NumberOfBytesToWrite, PULONG NumberOfBytesWritten);

RealNtWriteVirtualMemory NewNtWriteVirtualMemory = NULL;
//===========================================================================
class CPlayer
{
	public:
		int m_iTeamNum;
		int m_iHealth;
		BYTE Flags;

		bool m_boolIsDormant;
		bool m_boolIsDead;
		
		float m_flPosition[3];
		float m_flOrigin[3];
		float m_flViewOrigin[3];
		float m_flAngles[3];
		float m_flEyePosition[3];
};
//===========================================================================
std::vector<CPlayer> vecPlayers;
CPlayer LocalPlayer;
//===========================================================================
DWORD FindProcessByName(const char *__ProcessName, PROCESSENTRY32 *pEntry)
{
	PROCESSENTRY32 __ProcessEntry;
	__ProcessEntry.dwSize = sizeof(PROCESSENTRY32);

	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

	if(hSnapshot == INVALID_HANDLE_VALUE) return 0;        
		if(!Process32First(hSnapshot, &__ProcessEntry))
		{
			CloseHandle(hSnapshot);
			return NULL;
		}

		do{if(!_strcmpi(__ProcessEntry.szExeFile, __ProcessName))
		{
			memcpy((void *)pEntry,(void *)&__ProcessEntry, sizeof(PROCESSENTRY32));
			CloseHandle(hSnapshot);

			return __ProcessEntry.th32ProcessID;
		}
	} 

	while(Process32Next(hSnapshot, &__ProcessEntry));
		CloseHandle(hSnapshot);
		
		return NULL;
}
//===========================================================================
DWORD GetModuleByName(LPSTR LPSTRModuleName, DWORD __DwordProcessId)
{
	MODULEENTRY32 lpModuleEntry = {0};

	HANDLE hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, __DwordProcessId);

	if(!hSnapShot)
		return NULL;  
		
		lpModuleEntry.dwSize = sizeof(lpModuleEntry);

		BOOL __RunModule = Module32First(hSnapShot, &lpModuleEntry);
		
		while(__RunModule)
		{
			if(!strcmp(lpModuleEntry.szModule, LPSTRModuleName))
			{
				CloseHandle(hSnapShot);
				return(DWORD)lpModuleEntry.modBaseAddr;
			}
		__RunModule = Module32Next(hSnapShot, &lpModuleEntry);
	}
		
	CloseHandle(hSnapShot);
	
	return NULL;
}
//===========================================================================
void makeVector(float * vecIn, float * vecOut)
{
	float pitch =(float)((float)M_PI / 180.0f) * vecIn[0];
	float yaw	=(float)((float)M_PI / 180.0f) * vecIn[1];
	float temp	=(float)cos(pitch);
	vecOut[0]	=(float)(-temp * -cos(yaw));
	vecOut[1]	=(float)(sin(yaw) * temp);
	vecOut[2]	=(float)(-sin(pitch));
}
//===========================================================================
void calcAngle(float *src, float *dst, float *angles)
{
	double delta[3] = {(src[0]-dst[0]),(src[1]-dst[1]),(src[2]-dst[2])};
	double hyp = sqrt(delta[0]*delta[0] + delta[1]*delta[1]);
	angles[0] =(float)(asinf(delta[2]/hyp) * 57.295779513082f);
	angles[1] =(float)(atanf(delta[1]/delta[0]) * 57.295779513082f);
	angles[2] = 0.0f;
	if(delta[0] >= 0.0) {angles[1] += 180.0f;}
}
//===========================================================================
float getFov(float *vecAngles, float *vecSrc, float *vecEnd)
{
	float flAim[3], flAng[3];

	calcAngle(vecSrc, vecEnd, flAng);
	makeVector(vecAngles, flAim);
	makeVector(flAng, flAng);

	float mag_s = sqrt((flAim[0]*flAim[0]) +(flAim[1]*flAim[1]) +(flAim[2]*flAim[2])); 
	float mag_d = sqrt((flAim[0]*flAim[0]) +(flAim[1]*flAim[1]) +(flAim[2]*flAim[2])); 

	float u_dot_v = flAim[0]*flAng[0] + flAim[1]*flAng[1] + flAim[2]*flAng[2]; 

	float fov = acos(u_dot_v /(mag_s*mag_d)) *(180.0f / M_PI); 

	return fov;
}
//===========================================================================
float get3dDistance(float * myCoords, float * enemyCoords)
{
	return sqrt(
	pow(double(enemyCoords[0] - myCoords[0]), 2.0) +
	pow(double(enemyCoords[1] - myCoords[1]), 2.0) +
	pow(double(enemyCoords[2] - myCoords[2]), 2.0));
}
//===========================================================================
void getEnginePtr()
{
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEngine + 0x55B434), &dwEnginePtr, sizeof(DWORD), NULL);
}
//===========================================================================
DWORD getInCross()
{
	DWORD dwInCross;

	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwLocalPlayer + 0x23F8), &dwInCross, sizeof(DWORD), NULL);

	return dwInCross;
}
//===========================================================================
void getPlayers()
{
	vecPlayers.clear();

	for(int i = 0; i < 64; i++)
	{
		CPlayer tmpCPlayer;
		DWORD dwEntity;

		Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwClient + 0x4A13264 + (i * 0x10)), &dwEntity, sizeof(DWORD), NULL);
		Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEntity + 0xF0), &tmpCPlayer.m_iTeamNum, sizeof(int), NULL);
		Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEntity + 0xA0), &tmpCPlayer.m_flPosition, sizeof(float[3]), NULL);
		Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEntity + 0xFC), &tmpCPlayer.m_iHealth, sizeof(int), NULL);
		Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEntity + 0xE9), &tmpCPlayer.m_boolIsDormant, sizeof(bool), NULL);
		Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEntity + 0x25B), &tmpCPlayer.m_boolIsDead, sizeof(bool), NULL);
		
		vecPlayers.push_back(tmpCPlayer);

		if(m_boolLoopLock == false && dwEntity != 0 && tmpCPlayer.m_iTeamNum != LocalPlayer.m_iTeamNum && tmpCPlayer.m_boolIsDormant == false && tmpCPlayer.m_boolIsDead == false && tmpCPlayer.m_iHealth > 0 && tmpCPlayer.m_iHealth <= 100)
		{
			if(vars.SoundESP.Enabled == 1)
			{
				if(getFov(LocalPlayer.m_flAngles, LocalPlayer.m_flPosition, tmpCPlayer.m_flPosition) <(float)vars.SoundESP.FOV && get3dDistance(LocalPlayer.m_flPosition, tmpCPlayer.m_flPosition) <(float)vars.SoundESP.Distance)
				{
					if(GetAsyncKeyState(vars.SoundESP.OldSoundKey) < 0  && m_boolBeep == false)
					{
						Beep(850, 100);
						m_boolBeep = true;
						m_boolLoopLock = true;
					}
					if(GetAsyncKeyState(vars.SoundESP.NewSoundKey) < 0  && m_boolBeep == false)
					{
						PlaySound(TEXT("C:\\Beep.wav"), NULL, SND_FILENAME);
						m_boolBeep = true;
						m_boolLoopLock = true;
					}
					else
					{
						m_boolBeep = false;
					}
				}
			}
		}
	}
	m_boolLoopLock = false;
}
//===========================================================================
void getLocalPlayer()
{
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwClient + 0xA7094C), &dwLocalPlayer, sizeof(DWORD), NULL);
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwLocalPlayer + 0xF0), &LocalPlayer.m_iTeamNum, sizeof(DWORD), NULL);
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwLocalPlayer + 0xA0), &LocalPlayer.m_flPosition, sizeof(float[3]), NULL);
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwLocalPlayer + 0x134), &LocalPlayer.m_flViewOrigin, sizeof(float[3]), NULL);
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwLocalPlayer + 0x104), &LocalPlayer.m_flOrigin, sizeof(float[3]), NULL);
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwEnginePtr + 0x4CE0), &LocalPlayer.m_flAngles, sizeof(float[3]), NULL);
}
//===========================================================================
void bunnyHop()
{
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwClient + 0xA7094C), &dwLocalPlayer, sizeof(DWORD), NULL);
	Toolhelp32ReadProcessMemory(dwPid, LPVOID(dwLocalPlayer + 0x100), &LocalPlayer.Flags, sizeof(DWORD), NULL);
	
	if(LocalPlayer.Flags & (1 || 3 || 5 || 7))
		{
			//keybd_event(VK_SPACE, 0x39, 0, 0);
			SendMessage(FindWindow("Valve001", 0), WM_KEYDOWN, VK_SPACE, 0x390000);
			Sleep(30);
			//keybd_event(VK_SPACE, 0x39, KEYEVENTF_KEYUP, 0);
			SendMessage(FindWindow("Valve001", 0), WM_KEYUP, VK_SPACE, 0x390000);
			Sleep(30);
		}
	Sleep(1);
}
//===========================================================================
void shootWeapon()
{
	DWORD dwId = getInCross();

	if(vecPlayers.size() >= 1  && dwId <= vecPlayers.size())
	{
		if(dwId != 0 && LocalPlayer.m_iTeamNum != vecPlayers[dwId - 1].m_iTeamNum && LocalPlayer.m_iTeamNum != 0)
		{
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			Sleep(vars.TriggerBot.Burst);
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			Sleep(1);
		}
	}
}
//===========================================================================
struct GlowObjectDefinition_t
{
    void* pEntity;
    float r;
    float g;
    float b;
    float a;
    uint8_t unk1[16];
    bool m_bRenderWhenOccluded;
    bool m_bRenderWhenUnoccluded;
    bool m_bFullBloom;
    uint8_t unk2[13];
};
//===========================================================================
BOOL ResolveNativeApis()
{
	HMODULE ntdll = GetModuleHandleA("ntdll.dll");

	NtUnmapViewOfSection = (TypeNtUnmapViewOfSection)GetProcAddress(ntdll, "NtUnmapViewOfSection");
	if(!NtUnmapViewOfSection)
		return FALSE;

	NtCreateSection = (TypeNtCreateSection)GetProcAddress(ntdll, "NtCreateSection");
	if(!NtCreateSection)
		return FALSE;

	NtMapViewOfSection = (TypeNtMapViewOfSection)GetProcAddress(ntdll, "NtMapViewOfSection");
	if(!NtMapViewOfSection)
		return FALSE;

	NtClose = (TypeNtClose)GetProcAddress(ntdll, "NtClose");
	if(!NtClose)
		return FALSE;

	return TRUE;
}
//===========================================================================
BOOL RelocatePE(PBYTE CodeBuffer, LPVOID NewBase)
{
	DWORD delta, RelocTableOffset, TotalSize, RelocTableSize, EntryOffset;
	int NumberOfEntries;
	PWORD StartOfEntries;
	PIMAGE_NT_HEADERS NtHeaders;
	PIMAGE_BASE_RELOCATION reloc;

	delta = (DWORD)NewBase - (DWORD)GetModuleHandleA(NULL);

	NtHeaders = (PIMAGE_NT_HEADERS)((DWORD)CodeBuffer + 
		((PIMAGE_DOS_HEADER)CodeBuffer)->e_lfanew);
	
	if(NtHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress <= 0)
		return FALSE;

	RelocTableOffset = NtHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress;
	RelocTableSize = NtHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].Size;

	reloc = (PIMAGE_BASE_RELOCATION)&CodeBuffer[RelocTableOffset];

	for(TotalSize = 0; TotalSize < RelocTableSize; TotalSize += reloc->SizeOfBlock, *(DWORD *)&reloc += reloc->SizeOfBlock)
	{
		NumberOfEntries = (reloc->SizeOfBlock - sizeof(IMAGE_BASE_RELOCATION)) / sizeof(WORD);
		StartOfEntries = (PWORD)((DWORD)(reloc) + sizeof(IMAGE_BASE_RELOCATION));

		for(int i = 0; i < NumberOfEntries; i++)
		{
			if((StartOfEntries[i] >> 12) & IMAGE_REL_BASED_HIGHLOW)
			{
				EntryOffset = reloc->VirtualAddress + (StartOfEntries[i] & 0xFFF);
				*(PDWORD)&CodeBuffer[EntryOffset] += (delta);
			}
		}
	}

	return TRUE;
}
//===========================================================================
LPVOID InjectProcess(HANDLE ProcessHandle)
{
	DWORD OriginalBaseAddress, OurBaseAddress;
	PIMAGE_NT_HEADERS NtHeaders;
	PIMAGE_SECTION_HEADER SectionHeader;
	NTSTATUS status;
	HANDLE SectionHandle = NULL;
	LARGE_INTEGER SectionMaxSize = {0,0};
	PVOID LocalAddress = NULL, RemoteAddress = NULL;
	DWORD ViewSize = 0;
	int i;
	BOOL success = FALSE;

	do {

		OurBaseAddress = (DWORD)GetModuleHandle(NULL);

		NtHeaders = (PIMAGE_NT_HEADERS)((DWORD)OurBaseAddress + ((PIMAGE_DOS_HEADER)OurBaseAddress)->e_lfanew);
		if(NtHeaders->Signature != IMAGE_NT_SIGNATURE)
		{
			printf("File is not valid PE\n");
			break;
		}

		SectionMaxSize.LowPart = NtHeaders->OptionalHeader.SizeOfImage;

		status = NtCreateSection(&SectionHandle, SECTION_MAP_EXECUTE | SECTION_MAP_READ | SECTION_MAP_WRITE, NULL, &SectionMaxSize, PAGE_EXECUTE_READWRITE, SEC_COMMIT, NULL);
		if(!NT_SUCCESS(status))
		{
			printf("NtCreateSection() failed with error: %X\n", status);
			break;
		}

		status = NtMapViewOfSection(SectionHandle, GetCurrentProcess(), &LocalAddress, NULL, NULL, NULL, &ViewSize, 2, NULL, PAGE_EXECUTE_READWRITE);
		if(!NT_SUCCESS(status))
		{
			printf("NtMapViewOfSection() failed with error: %X\n", status);
			break;
		}

		status = NtMapViewOfSection(SectionHandle, ProcessHandle, &RemoteAddress, NULL, NULL, NULL, &ViewSize, 2, NULL, PAGE_EXECUTE_READWRITE);
		if(!NT_SUCCESS(status))
		{
			printf("NtMapViewOfSection() failed with error: %X\n", status);
			break;
		}

		memcpy(LocalAddress, (LPVOID)OurBaseAddress, NtHeaders->OptionalHeader.SizeOfImage);
		RelocatePE((PBYTE)LocalAddress, RemoteAddress);

		success = TRUE;
		
	} while (FALSE);

	if(success == FALSE && RemoteAddress != NULL)
	{
		NtUnmapViewOfSection(ProcessHandle, RemoteAddress);
		RemoteAddress = NULL;
	}

	if(LocalAddress != NULL)
		NtUnmapViewOfSection(GetCurrentProcess(), LocalAddress);

	if(SectionHandle != NULL)
		NtClose(SectionHandle);

	return RemoteAddress;
}
//===========================================================================
int CreateHollowedProcess(WCHAR *ImagePath)
{
	BOOL success = FALSE;
	PROCESS_INFORMATION ProcessInfo = {0};
	STARTUPINFOW StartupInfo = {0};
	CONTEXT ThreadContext;
	LPVOID BaseAddress;

	do {

		if(!ResolveNativeApis())
		{
			printf("Failed to resolve functions from ntdll\n");
			break;
		}

		if(!CreateProcessW(NULL, ImagePath, NULL, NULL, FALSE, CREATE_SUSPENDED, NULL, NULL, &StartupInfo, &ProcessInfo))
		{
			printf("CreateProcessA() Failed with error: %d\n", GetLastError());
			break;
		}

		BaseAddress = InjectProcess(ProcessInfo.hProcess);
		if(!BaseAddress)
		{
			printf("Failed to remap process\n");
			break;
		}
		
		ThreadContext.ContextFlags = CONTEXT_FULL;

		if(!GetThreadContext(ProcessInfo.hThread, &ThreadContext))
		{
			printf("GetThreadContext() Failed with error: %d\n", GetLastError());
			break;
		}

		ThreadContext.Eax = (DWORD)((DWORD)&RemoteMain - (DWORD)GetModuleHandle(NULL)) + (DWORD)BaseAddress;

		if(!SetThreadContext(ProcessInfo.hThread, &ThreadContext))
		{
			printf("SetThreadContext() Failed with error: %d\n", GetLastError());
			break;
		}

		if(!ResumeThread(ProcessInfo.hThread))
		{
			printf("Failed to un-suspend process, Error: %d\n", GetLastError());
			break;
		}

		printf("{Injection Succesful}\n" \
			"%ws\n" \
			"Remote Base Address: 0x%X\n" \
			"Remote Entry Point:  0x%X\n",
			ImagePath,
			ThreadContext.Eax,
			BaseAddress);

		success = TRUE;

	} while (FALSE);

	if(success == FALSE && ProcessInfo.hProcess != NULL)
	{
		TerminateProcess(ProcessInfo.hProcess, 0);
	}

	if(ProcessInfo.hProcess != NULL)
		CloseHandle(ProcessInfo.hProcess);

	if(ProcessInfo.hThread != NULL)
		CloseHandle(ProcessInfo.hThread);

	return success;
}
//===========================================================================
int main()
{
	WCHAR ImagePath[MAX_PATH];

	ExpandEnvironmentStringsW(L"%windir%\\explorer.exe", ImagePath, MAX_PATH-1);
	CreateHollowedProcess(ImagePath);

	getchar();
	return 0;
}
//===========================================================================
int RemoteMain()
{
	NewNtWriteVirtualMemory = (RealNtWriteVirtualMemory)GetProcAddress(GetModuleHandle("ntdll.dll"),"NtWriteVirtualMemory");

	vars.LoadCfg();

	while(dwPid == NULL)
	{
		PROCESSENTRY32 peEntry;
		dwPid = FindProcessByName("Game.exe", &peEntry);
		Sleep(500);
	}

	while(dwClient == NULL)
	{
		dwClient = GetModuleByName("client.dll", dwPid);
		Sleep(500);
	}

	while(dwEngine == NULL)
	{
		dwEngine = GetModuleByName("engine.dll", dwPid);
		Sleep(500);
	}

	while(hHandle == INVALID_HANDLE_VALUE) 
	{
		hHandle = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwPid);
		Sleep(500);
	}

	while(true)
	{
		getLocalPlayer();
		getPlayers();
		getEnginePtr();

		if(GetAsyncKeyState(vars.ConfigRefresh.Key) < 0)
		{
			vars.LoadCfg();
			Sleep(1);
		}
	}
	return 0;
}
//===========================================================================